// 2013-01-28

// (C) John COLIBRI 2013
// documentation: http://www.jcolibri.com

(*$r+*)

unit u_11_edit_stylehook_color;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls,
  Vcl.ComCtrls, Vcl.ExtCtrls, Vcl.Menus, Vcl.Mask;

type
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    TabSheet2: TTabSheet;
    Panel1: TPanel;
    Splitter1: TSplitter;
    Panel2: TPanel;
    exit_: TButton;
    clear_: TButton;
    Panel7: TPanel;
    list_BDSUSERDIR_vsf_styles_: TButton;
    vsf_style_listbox_: TListBox;
    Panel4: TPanel;
    list_registered_styles_: TButton;
    registered_styles_listbox_: TListBox;
    Panel3: TPanel;
    register_edit_background_hook_: TButton;
    unregister_edit_background_hook_: TButton;
    register_edit_stylehook_: TButton;
    unregister_edit_stylehook_: TButton;
    enable_edit2_: TCheckBox;
    Panel5: TPanel;
    Button1: TButton;
    Label1: TLabel;
    CheckBox1: TCheckBox;
    ListBox1: TListBox;
    ScrollBar1: TScrollBar;
    PageControl2: TPageControl;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    TreeView1: TTreeView;
    Edit1: TEdit;
    Edit2: TEdit;
    Memo1: TMemo;
    enable_edit1_: TCheckBox;
    Label2: TLabel;
    procedure exit_Click(Sender: TObject);
    procedure clear_Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure red1Click(Sender: TObject);
    procedure list_BDSUSERDIR_vsf_styles_Click(Sender: TObject);
    procedure list_registered_styles_Click(Sender: TObject);
    procedure vsf_style_listbox_Click(Sender: TObject);
    procedure registered_styles_listbox_Click(Sender: TObject);
    procedure register_edit_background_hook_Click(Sender: TObject);
    procedure unregister_edit_background_hook_Click(Sender: TObject);
    procedure register_edit_stylehook_Click(Sender: TObject);
    procedure unregister_edit_stylehook_Click(Sender: TObject);
    procedure enable_edit2_Click(Sender: TObject);
    procedure enable_edit1_Click(Sender: TObject);
  private
  public
  end;

var
  Form1: TForm1;

  implementation
  uses Vcl.Styles, Vcl.Themes,
    u_display_simple
         , u_styles_helpers
  ,   u_c_edit_stylehook_color
  , u_c_my_teditstylehook
  ;

    {$R *.dfm}

    var g_did_register_hooks: boolean= False;

    procedure TForm1.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
      end;

    procedure TForm1.list_BDSUSERDIR_vsf_styles_Click(Sender: TObject);
      begin
        list_BDSUSERDIR_vsf_files(vsf_style_listbox_.Items);
      end;

    procedure TForm1.list_registered_styles_Click(Sender: TObject);
       begin
        list_registered_styles(registered_styles_listbox_.Items);
      end;

    procedure TForm1.clear_Click(Sender: TObject);
      begin
       Memo1.LInes.Clear;
      end;

    procedure TForm1.exit_Click(Sender: TObject);
      begin
        Close;
      end;

    procedure TForm1.red1Click(Sender: TObject);
      begin
        Panel1.Color:= clRed;
      end; // red1Click

    procedure TForm1.vsf_style_listbox_Click(Sender: TObject);
      var l_vsf_filename: String;
      begin
        with vsf_style_listbox_ do
        begin
          if ItemIndex< 0
            then begin
                display('*** no vsf selected');
                Exit;
              end
            else
              l_vsf_filename:= Items[ItemIndex]  ;

          load_BDSUSERDIR_vsf_style(k_BDSUSERDIR+ 'styles\'+ l_vsf_filename);

          // -- remove from vsf name list
          Items.Delete(ItemIndex);
        end;

        // -- redisplay the registered styles
        list_registered_styles_Click(Nil);
      end; // vsf_style_listbox_Click

    procedure TForm1.registered_styles_listbox_Click(Sender: TObject);
      var l_style_name: String;
      begin
        with registered_styles_listbox_ do
          l_style_name:= Items[ItemIndex];

        TStyleManager.SetStyle(l_style_name);
        Caption:= l_style_name;
        label2.Caption:= l_style_name;
      end; // registered_styles_listbox_Click

    // -- style hooks

    // -- 1 derived from tEditHook

    procedure TForm1.register_edit_stylehook_Click(Sender: TObject);
      begin
        TStyleManager.Engine.RegisterStyleHook(TEdit, tMyEditStyleHook);

        unregister_edit_stylehook_.Enabled:= True;
        register_edit_stylehook_.Enabled:= False;
      end; // register_edit_stylehook_Click

    procedure TForm1.unregister_edit_stylehook_Click(Sender: TObject);
      begin
        TStyleManager.Engine.UnRegisterStyleHook(TEdit, tMyEditStyleHook);

        unregister_edit_stylehook_.Enabled:= False;
        register_edit_stylehook_.Enabled:= True;
      end; // unregister_edit_stylehook_Click

    // -- 2 derived from tEditHook

    procedure TForm1.register_edit_background_hook_Click(Sender: TObject);
      begin
        TStyleManager.Engine.RegisterStyleHook(TEdit, TEditStyleHookColor);

        register_edit_background_hook_.Enabled:= False;
        unregister_edit_background_hook_.Enabled:= True;
      end; // register_stylehooks_Click

    procedure TForm1.unregister_edit_background_hook_Click(Sender: TObject);
      begin
        TStyleManager.Engine.UnRegisterStyleHook(TEdit, TEditStyleHookColor);
        register_edit_background_hook_.Enabled:= True;
        unregister_edit_background_hook_.Enabled:= False;
      end; // unregister_stylehooks_Click

    procedure TForm1.enable_edit2_Click(Sender: TObject);
      begin
        display('');
        display('toggle_Edit2.Enabled');
        Edit2.Enabled:= Not Edit2.Enabled;
      end;

    procedure TForm1.enable_edit1_Click(Sender: TObject);
      begin
        display('');
        display('toggle_Edit1.Enabled');
        Edit1.Enabled:= Not Edit1.Enabled;
      end;

    end.
