// 2013-01-28

// -- (C) John COLIBRI 2013
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_c_my_teditstylehook;
  interface
    uses Windows, Winapi.Messages, Vcl.Themes, Vcl.StdCtrls, Graphics, Vcl.Controls;

    type tMyEditStyleHook=
             class(TStyleHook)
               strict private
                 procedure UpdateColors;
                 procedure do_display(p_text: String);
               strict protected
  //               procedure PaintNC(Canvas: TCanvas); override;
                 procedure WndProc(var Message: TMessage); override;
               public
                 constructor Create(AControl: TWinControl); override;
             end; // tMyEditStyleHook

  implementation
    uses SysUtils
        , System.Types // tRect
        , u_display_simple
        , u_styles_helpers;

    { tMyEditStyleHook }

    constructor tMyEditStyleHook.Create(AControl: TWinControl);
      begin
        inherited;

//        OverridePaintNC:= True;
        OverrideEraseBkgnd:= True;
        UpdateColors;
      end; // Create

    procedure tMyEditStyleHook.do_display(p_text: String);
      begin
        display(Format('%-6s %s', [Control.Name, p_text]));
      end; // do_display

(*
    procedure tMyEditStyleHook.PaintNC(Canvas: TCanvas);
      var l_c_themed_element_details: TThemedElementDetails;
          l_rectangle: TRect;
      begin
        if StyleServices.Available
          then
            begin
              do_display('paintNc');
              l_c_themed_element_details:= StyleServices.GetElementDetails(
                  teEditBorderNoScrollNormal);

              l_rectangle:= Rect(0, 0, Control.Width, Control.Height);
              InflateRect(l_rectangle, - 2, - 2);
              ExcludeClipRect(Canvas.Handle, l_rectangle.Left, l_rectangle.Top,
                  l_rectangle.Right, l_rectangle.Bottom);

              StyleServices.DrawElement(Canvas.Handle, l_c_themed_element_details,
                  Rect(0, 0, Control.Width, Control.Height));
            end;
      end; // PaintNC
*)
    procedure tMyEditStyleHook.UpdateColors;
      const k_style_color_array: array[Boolean] of TStyleColor=
                (scEditDisabled, scEdit);
            k_style_font_array: array[Boolean] of TStyleFont=
                (sfEditBoxTextDisabled, sfEditBoxTextNormal);
      var l_c_custom_style_services: TCustomStyleServices;
      begin
        l_c_custom_style_services:= StyleServices;

        Brush.Color:= l_c_custom_style_services.GetStyleColor(
            k_style_color_array[Control.Enabled]);
        FontColor:= l_c_custom_style_services.GetStyleFontColor(
            k_style_font_array[Control.Enabled]);
        do_display(Format('UpdateColors brush %8x  font %8x',
            [Brush.Color, FontColor]));
      end; // UpdateColors

    procedure tMyEditStyleHook.WndProc(var Message: TMessage);
      begin
        case Message.Msg of
          CN_CTLCOLORMSGBOX..CN_CTLCOLORSTATIC:
              begin
                do_display(Format('cn %s', [f_display_cn(Message.Msg)]));
                SetTextColor(Message.WParam, ColorToRGB(FontColor));
//                SetBkColor(Message.WParam, ColorToRGB(Brush.Color));
                SetBkColor(Message.WParam, clFuchsia);

                Message.Result:= LRESULT(Brush.Handle);
                Handled:= True;
              end;

          CM_ENABLEDCHANGED:
              begin
                do_display('cm_enabledchanged');
                UpdateColors;

                Handled:= False; // Allow control to handle message
              end
          else inherited WndProc(Message);
        end;
      end; // WndProc

    begin // u_zzz

    end.// u_zzz
