// -- 2013-01-28

// -- (C) John COLIBRI 2007
// -- documentation: http://www.jcolibri.com

unit u_display_simple;
  interface
    uses Classes;


    procedure initialize_display(p_c_strings: tStrings);
    function f_spaces(p_space_count: integer): String;
    procedure display(p_text: String);
    function f_display_TF(p_boolean: Boolean): String;
    procedure clear_display;
    procedure save_display;

    var g_c_simple_strings_ref: tStrings= Nil;
        g_stop_display: Boolean= False;
        g_indentation: Integer= 0;

  implementation
    uses Windows, SysUtils, Forms;

    procedure initialize_display(p_c_strings: tStrings);
      begin
        g_c_simple_strings_ref:= p_c_strings;
      end; // initialize_display

    function f_spaces(p_space_count: integer): String;
      begin
        Result:= Format('%'+ IntToStr(p_space_count)+'s', ['']);
      end; // f_spaces

    procedure display(p_text: String);
      var l_text: String;
          l_length: Integer;
          l_negative_indentation: Integer;
          l_delete_line: Integer;
      begin
        if g_stop_display or (g_c_simple_strings_ref= Nil)
          then Exit;

        if g_indentation< 0
          then begin
              l_negative_indentation:= g_indentation;
              g_indentation:= 0;
              display('***- negative indent '+ IntToStr(l_negative_indentation));
            end;

        l_length:= Length(p_text);
        if (l_length> 0) and (p_text[1]= '<')
          then begin
              dec(g_indentation, 2);
              if g_indentation< 0
                then begin
                    g_indentation:= 0;
                    display('***+ negative indent');
                  end;
            end;

        l_text:= f_spaces(g_indentation)+ p_text;

        g_c_simple_strings_ref.Add(l_text);

        if (l_length> 0) and (p_text[1]= '>')
          then inc(g_indentation, 2);
      end; // display

    function f_display_TF(p_boolean: Boolean): String;
      begin
        if p_boolean
          then Result:= 'T'
          else Result:= 'F';
      end; // display_TF

    procedure clear_display;
      begin
        g_c_simple_strings_ref.Clear;
      end;
      
    procedure save_display;
      begin
        g_c_simple_strings_ref.SaveToFile(ChangeFileExt(Application.ExeName, '_log.txt'));
      end;

  end.
